/* 
 * \file        GHMFiltering.h
 * \author      Carlos Lopez Molina (carlos.lopez@unavarra.es)
 * \version     1.0
 * 
 * \section     Description
 * 
 * Header file for GHMFiltering class
 *
 * 
 */


#ifndef GHMFILTERING_H
#define	GHMFILTERING_H

namespace GHMFiltering {

    
    float *computeGHMImage(float **imgFiltered, int h, int w, float **Mu, float **Mv,float **energy, float **magn, float support, float sigma, float lambda);
    float *computeHermitePoly(float **y,int order,float *xValues, int length);
    void recursiveHermite(float **polynomial,int order);
    void computeGHFilter(float ***filter, float *vValues, int vLength, int vOrder,float *hValues, int hLength, int hOrder,float sigma);

    void computeCoherence(float **C, int h, int w, float **xCos, float **ySin,int halfWindowSize);
    void computeCoherence(float **C, int h, int w, float **xCos, float **ySin,int halfWindowSize, int *ySpan, int *wSpan);
    
}

#endif	/* GHMFILTERING_H */

