/* 
 * File:   GuardarRealce.cpp
 * Author: jcerron
 * 
 * Created on 5 de diciembre de 2012, 10:20
 */

 
 /* 
 * \file        GuardarRealce.cpp
 * \author      Juan Cerrón González (juan.cerron@unavarra.es)
 * \version     1.0
 * 
 * \section     DESCRIPTION
 * 
 * The implementation of GuardarRealce class
 *
 * 
 */


#include "MemUtil.hpp"
#include "ImgUtil.h"
#include "FingerprintImg.h"
#include "ImageEnhancementHong.h"
#include "ParametersLeung.h"

#include "GuardarRealce.h"

GuardarRealce::GuardarRealce() {
}

GuardarRealce::GuardarRealce(const GuardarRealce& orig) {
}

GuardarRealce::~GuardarRealce() {
}

void GuardarRealce::run(string file, PCASYSManager *pcasys, int VO, int MO) {
    FingerprintImg fi;

    if (ImgUtil::fAdjust != 1) {
        fi.setPCASYSManager(pcasys);
        fi.readFingerprintImage(file);
        fi.setSegmentedPCASYS(fi.getImage(), fi.getH(), fi.getW());
    } else {
        fi.setPCASYSManager(pcasys);
        fi.readFingerprintImage(file);
        fi.segment();
    }
    float **imgEnhanced;
    ImageEnhancementHong *ieh = new ImageEnhancementHong(fi.getSegmentedImage(), fi.getH(), fi.getW());
    ieh->enhance(MO, VO, true);
    int aux = gaborSupLeungHong * ImgUtil::fAdjust;
    if (aux % 2 == 0)
        aux--;
    imgEnhanced = ieh->filterImage(aux, deltaGaborLeungHong * ImgUtil::fAdjust, deltaGaborLeungHong * ImgUtil::fAdjust, true);

    escribir(file, imgEnhanced, fi.getH(), fi.getW());

    MemUtil::freeMatrix(&imgEnhanced);

    delete ieh;

}

void GuardarRealce::escribir(string file, float **imagen, int h, int w) {

    ofstream salida;

    cout << file << endl;
    //Vaciamos el fichero si ya estaba creado
    salida.open(file.c_str(), ios::binary | ios::trunc);
    salida << "";
    salida.close();

    //Reescribimos la matriz
    salida.open(file.c_str(), ios::binary | ios::app);

    salida << h << endl;
    salida << w << endl;

    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            bool b = (((int) imagen[i][j]) / 255) == 1;
            salida << b << endl;
        }
    }

    //salida.write(reinterpret_cast<char *>(&imagen),sizeof(float **));

    salida.close();
}

unsigned char *GuardarRealce::leer(string fileName, int *h, int *w) {

    ifstream salida;
    bool b;

    unsigned char *image;

    //Leemos la matriz
    salida.open(fileName.c_str(), ios::binary | ios::in);
    if (!salida.is_open()) {
        cout << "No se ha podido leer la imagen realzada" << endl;
        return 0;
    }

    cout << "Leida imagen realzada" << endl;

    salida >> h[0];
    salida >> w[0];

    cout << h[0] << endl;
    cout << w[0] << endl;


    image = MemUtil::createVector<unsigned char>(h[0] * w[0]);

    for (int i = 0; i < h[0] * w[0]; i++) {

        salida >> b;
        if (b)
            image[i] = 255;
        else
            image[1] = 0;
    }

    salida.close();

    return image;
    //salida.read((char *)(&img),sizeof(float **))

    //ImgUtil::writeGrayScaleImage(img, h, w, "PruebasLectura",1);
}
