/* 
 * \file        LinWangSegmentation.h
 * \author      Mikel Galar Idoate (mikel.galar@unavarra.es)
 * \author      Carlos Lopez Molina (carlos.lopez@unavarra.es)
 * \version     1.0
 * 
 * \section     DESCRIPTION
 * 
 * Header file for LinWangSegmentation class
 *
 * 
 */

#ifndef LINWANGSEGMENTATION_H
#define	LINWANGSEGMENTATION_H

class LinWangSegmentation {
public:
    LinWangSegmentation(int h, int w);
    LinWangSegmentation(const LinWangSegmentation& orig);
    
    virtual ~LinWangSegmentation();
    

    
    void setEnergy(float **E);
    void setCoherence(float **C);
    
    void createSegmentation();
    void createSmoothSegmentation(int halfWindowSize);
    
    void GaussianFiltering(float ***image, int h, int w, int gausFilterH, int gausFilterW, float sigma);
    
    bool **getSegmentation();
    bool **getSmoothSegmentation();
    bool **getBlockwiseSegmentation(int blockSize,bool isOverlapping);
    bool **getBlockwiseSmothSegmentation(int blockSize,bool isOverlapping);
    
    void tileImageOverlapping(bool **originalImage,int blockSize);
    void tileImage(bool **originalImage,int blockSize);
    
    
private:

    float **energy;
    float **coherence;
    bool **segmentation;
    bool **smoothSegmentation;
    bool **tiledImage;
    
    int h;
    int w;
    
};

#endif	/* LINWANGSEGMENTATION_H */

