/* 
 * \file        ParametersKaru.h
 * \author      Mikel Galar Idoate (mikel.galar@unavarra.es)
 * \version     1.0
 * 
 * \section     DESCRIPTION
 * 
 * The declaration of the parameters used in Karu
 *
 * 
 */


#ifndef PARAMETERSKARU_H
#define	PARAMETERSKARU_H

const int cleanCoresKaru = 80;          //!< Distance from the border on which cores are not allowed (in pixels)
const int cleanCoresDeltasKaru = 40;    //!< Distance from the border on which deltas are not allowed (in pixels)

const int cleanCoreDeltaPairInKaru = 8;         //!< Minimum distance between delta and core points in the region inside the cleanCoresDeltasKaru (in pixels)
const int cleanCoreDeltaPairOutKaru = 24;       //!< Minimum distance between delta and core points in the region outside the cleanCoresDeltasKaru  (in pixels)

const float thresholdTentedArcKaru = 0.2;       //!< Threshold to be used for the detection of tented archs in karu

const int blockWKaru = 8;       //!< Block size for the computation of the orientation map (the smooth after the computation of pixel orientation

const int orienationMaskSizeKaru = 9;       //!< Size of the orientation mask for the computation of the pixel orientation

const int smoothWKaru = 3; //!< Size of the smoothing window for the first smooth after the block orientation computation

const int curveWKaru = 2; //!< Size of the digital curve to be used in poincare

const int smoothWPoincareKaru = 3; //!< Size of the smoothing window to be used in poincaré if more than 2 cores or deltas are found 

const int rulesToBeAppliedKaru = 1; //!< Karu rules are applied

const int minNBlocksKaru = 0; //!< Minimum number of blocks needed to consider a core or delta as a singular point

const bool normalizeKaru = false; //!< Whether to normalize the orientation map components after the smoothing of the map


const operationModePoincare poincareModeKaru = increasingSmoothPoincare; //!< The operation prcedure for poincare

#endif	/* PARAMETERSKARU_H */

