/* 
 * \file        ParametersLinWangFE.h
 * \author      Carlos Lopez Molina (carlos.lopez@unavarra.es)
 * \version     1.0
 * 
 * \section     DESCRIPTION
 * 
 * The definition of LinWangFE's parameters
 *
 * 
 */

#ifndef PARAMETERSLINWANGFFE_H
#define	PARAMETERSLINWANGFFE_H

////////////////////////////
// Orientation Block Size //
////////////////////////////
const int blockSizeLinWangFE = 16;                  //!< Size to create the orientation image.

///////////////////////////////
// Gaussian Filter Parameters//
///////////////////////////////
const double sigmaLinWangFE = 1.4;                  //!< Sigma for the gaussian filter
const int gFilterHLinWangFE = 5;                    //!< Height of he gaussian filter
const int gFilterWLinWangFE = 5;                    //!< Width of he gaussian filter

//////////////////////////
// Coherence Parameters //
//////////////////////////
const double thresholdFactorLinWangFE = 0.18;       //!< Threshold factor adjust
const int maxLabelsLinWangFE = 60;                  //!< Maximum connected components to find

//////////////////////////
//
//////////////////////////
const float lambdaLinWangFE=0.5;
const int ghmSupportHalfSizeLinWangFE=10;
const float ghmSigmaLinWangFE=1.0;

//////////////////////////
// Smoothing Parameters //
//////////////////////////
const int blockLLinWangFE = 5;                      //!< Smoothing window length  
const int blockWLinWangFE = 3;                      //!< Smoothing window width
const float thresholdCLinWangFE = 0;                //!< Threshold used to calculate Mu in smoothing

///////////////////////////
// Core & Delta Analysis //
///////////////////////////

const float blockArroundCoreL_LinWangFE = 4;             //!< Core and delta analysis block lenght
const float blockArroundCoreW_LinWangFE = 2;              //!< Core and delta analysis block width
const int curveWLinWangFE = 2;                      //!< Size of the matrix with wich the core curve is searched
const int minNumBlockLinWangFE = 0;                 //!< Minimum number of blocks needed to consider a core or delta correct
const operationModePoincare poincareModeLinWangFE = increasingSmoothPoincare; //<! Operation mode for the poincare method

const int rulesToBeAppliedLinWangFE = 5; //5; //!< Karu rules are applied
const bool normalizeLinWangFE = true; //!< Whether to normalize the orientation map componenets in poincare or not

//////////////////////////////
// Eliminate Singular Point //
//////////////////////////////
const float minDistanceLinWangFE = 10;//4;                 //!< Minimum distance to consider independent cores and deltas

const int thresholdTentedArchLinWangFE = 600;            //!< s threshold to consider a right/left loop instead of a tented arch
        
const int pseudoRidgeSizeLinWangFE = 150;                        //!< Number of pixels which are followed by the pseudo-ridge

const int smoothWPoincareLinWangFE = 3;                      //!< Smoothing window length  poincare

const float blockArroundCoreLLinWangFE = 4;             //!< Core and delta analysis block lenght
const float blockArroundCoreWLinWangFE = 2;   

const int coherenceHalfWindowLinWangFE=15;

const int segmentationSmoothingWindow_LinWangFE=7;

/////////////////
//
////////////////////////////
const int candidatesScopeLinWangFE=15;
const int localMinSpaceLinWangFE=10;
const int noSPmarginLinWangFE=40;


#endif	/* PARAMETERSLINWANGFFE_H */

