/* 
 * \file        ParametersNyongesa.h
 * \author      Mikel Galar Idoate (mikel.galar@unavarra.es)
 * \version     1.0
 * 
 * \section     DESCRIPTION
 * 
 * The declaration of the parameters used in Nyongesa
 *
 * 
 */

#ifndef PARAMETERSNYONGESA_H
#define	PARAMETERSNYONGESA_H

const int binarizationWNyongesa = 8; //!< Window size for the binarization of the fingerprint
const int blockWPixelOrientationNyongesa = 5;   //!< Block size for the computation of the pixel orientation
const int blockWAverageOrientationNyongesa = 5; //!< Block size for the computation of the average orientation from pixel orientation
const int smoothWOrientationNyongesa = 15;      //!< Size of the window for the first smoothing after the computation of the average orientation

const int curveWNyongesa = 8; //!< Size of the digital curve to be used in poincare

const int smoothWPoincareNyongesa = 3; //!< Size of the smoothing window to be used in poincaré if more than 2 cores or deltas are found and the curve has been decreased to 1 

const int rulesToBeAppliedNyongesa = 1; //!< Karu rules are applied

const int minNBlocksNyongesa = 0; //!< Minimum number of blocks needed to consider a core or delta as a singular point

const operationModePoincare poincareModeNyongesa = decreasingCurvePoincare; //!< The operation prcedure for poincare


#endif	/* PARAMETERSNYONGESA_H */

