 /* 
 * \file        ParametersShah.h
 * \author      Jose Antonio Sanz Delgado (joseantonio.sanz@unavarra.es)
 * \version     1.0
 * 
 * \section     DESCRIPTION
 * 
 * The parameters for the algorithm of Shah  
 *
 * 
 */

#ifndef PARAMETERSSHAH_H
#define	PARAMETERSSHAH_H

//////////////////////////////////////////////////////////
//      SHAH/SASTRY THINNING   LINE DETECTION PROCESS   //
//////////////////////////////////////////////////////////

const int MShah = 3; /*Parameter to determine the size of the neighbourhood*/
const int thresholdFeedbackShah = 35; /* The threshold to compute the feedback component (OIk)*/
const int thresholdEdgeShah = 0; /* The threshold to compute the edge strength (S)*/
const int WShah = 16; /*Size of the block used to binarize the fingerprint image*/

///////////////////////////////////////
//      SHAH/SASTRY THINNING         //
///////////////////////////////////////

const int sizeBlockNoiseShah = 9; /*Size of the bolck to remove the noise in the thinning process*/
const int noiseLineDistanceShah = 15;  /*Lines lower to this distance are deleted in the purge process*/

#endif	/* PARAMETERSSHAH_H */

