/* 
 * \file        main.cpp
 * \author      Mikel Galar Idoate (mikel.galar@unavarra.es)
 * \version     1.0
 * 
 * \SECTION     Description
 * 
 * Main file for the feature extraction procedure
 * 
 * 
 */
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <vector>
#include <string.h>
#include <stdio.h>
#include <iostream>

#include "EjecutarMetodo.h"

using namespace std;

int main(int argc, char** argv) {

    EjecutarMetodo *exe = new EjecutarMetodo();

    char* directorio = 0;
    char* metodo = 0;
    char* fichSalida = 0;
    bool ajustar = false;
    bool realzar = false;
    bool hayFichSalida = false;
    bool debug = false;

    int i = 1;
    while (i < argc) {
        string aux = argv[i];

        //Leemos el método
        if (aux.compare("-m") == 0) {
            metodo = argv[++i];
            cout << "Leido metodo: " << metodo << endl;
        }            //Leemos el fichero de salida
        else if (aux.compare("-f") == 0) {
            hayFichSalida = true;
            fichSalida = argv[++i];
            cout << "Leido fichero de salida: [" << fichSalida << "]" << endl;
        }            //Leemos el directorio
        else if (aux.compare("-d") == 0) {
            directorio = argv[++i];
            cout << "Leido directorio: " << directorio << endl;
        }            //Leemos el tipo de ajuste (redimension por defecto)
        else if (aux.compare("-a") == 0) {
            if (atoi(argv[++i]) == 1) {
                ajustar = true;
                cout << "Leido ajuste por fAdjust (1)" << endl;
            }
        } else if (aux.compare("-r") == 0) {
            realzar = true;
            cout << "Leido hacer realce (-r)" << endl;
        } else if (aux.compare("-debug") == 0) {
            debug = true;
        }
        i++;
    }

    if (metodo == 0 || directorio == 0) {
        cout << "Execution: <-d wsq file or directory> <-m method>  [-a 1(adjust) | 0(redimension)] [-f output file]  [-debug]" << endl;

        delete exe;

        return 0;
    }

    exe->ejecutar(directorio, metodo, fichSalida, ajustar, realzar, hayFichSalida, debug);

    delete exe;

    return 0;
}

